/* print out all chars in a bpsf font file */

#include <stdio.h>
#include <assert.h>
#include "bpsf.h"

/* find the ucs index from the unicode map */
unsigned short locate(unsigned short map[], unsigned i) {
    unsigned j;
    for (j = 0; j < 65536; ++j) {
        if (map[j] == i)
            return j;
    }
    printf("wrong value of i:%d\n", i);
    assert("can not reach here");
}

void display(unsigned char* buf, unsigned w, unsigned h) {
    unsigned x, y;
    for (y = 0; y < h; ++y) {
        for (x = 0; x < w; ++x) {
            if ((buf[x/8] >> (7-(x%8))) & 0x01)
                printf("+");
            else
                printf(" ");
        }
        buf += w/8;
        printf("\n");
    }
}

int main(int argc, char **argv) {
    char* file;
    char* bitmap;
    bpsf_info* info;
    unsigned i;
    unsigned short ucs;

    assert(argc == 2);
    file = argv[1];

    info = bpsf_create();
    bpsf_open(info, file);

    bitmap = info->m_bitmap;
    for (i = 0; i < info->m_glyph_count; ++i) {
/*    for (i = 0; i < 2; ++i) {*/
        ucs = locate(info->m_unicode_map, i);
        printf("0x%.4x\n", ucs);
        display(bitmap + i * info->m_glyph_size, info->m_width, info->m_height);
    }

    bpsf_destory(info);
    return 0;
}

