#include "minunit.h"
#include "bpsf.h"
#include <stdio.h>

int tests_run = 0;

char* test_init() {
    bpsf_info* info;
    mu_assert(info = bpsf_create());
    mu_assert(info->m_filename == (const char*)0);
    mu_assert(info->m_bitmap == (void*)0);
    mu_assert(info->m_height == 0u);
    mu_assert(info->m_width == 0u);
    mu_assert(info->m_glyph_size == 0u);
    mu_assert(info->m_glyph_count == 0u);
    mu_assert(info->m_use_mmap == 0);
    return 0;
}

char* test_open() {
    bpsf_info* info = bpsf_create();

    mu_assert(bpsf_open(info, "no such file") != 0);

    mu_assert(bpsf_open(info, "cjk16.bpsf") == 0);
    mu_assert(strcmp(info->m_filename, "cjk16.bpsf") == 0);
    mu_assert(info->m_width == 16);
    mu_assert(info->m_height == 16);
    mu_assert(info->m_glyph_size == 32);
    printf("glypy count:%d\n", info->m_glyph_count);
    printf("use mmap:%d\n", info->m_use_mmap);
    mu_assert(bpsf_destory(info) == 0);
    return 0;
}

static char * all_tests() {
     mu_run_test(test_init);
     return 0;
 }
 
int main(int argc, char **argv) {
    char *result = all_tests();
    if (result != 0) {
        printf("%s\n", result);
    }
    else {
        printf("ALL TESTS PASSED\n");
    }
    printf("Tests run: %d\n", tests_run);

    return result != 0;
}

